
#include "stdlibincl.h"
#include <stdarg.h>
#include <stdio.h>
#include "shell_buffer.h"
#include "class_list.h"

#include "network_manager.h"
#include "network_socket.h"

int verbose = 4;


int startHelp(int argc, char** argv)
{
  printf("Network is a network unit test\n");
  printf(" --help:           this output\n");
  printf(" --sockettest      test network_socket\n");
  printf("\n");
}

int testSocket(int argc, char** argv)
{
  NetworkSocket client;
  NetworkSocket server;
  IPaddress ip;
  SDLNet_ResolveHost(&ip, "127.0.0.1", 9999);
  server.listen(9999);
  client.connectToServer(ip, 9999);
  char buf[1024];

  printf("read from client before sending data\n");
  printf("result: %d bytes\n", client.readBytes((byte*)buf, 1024));

  printf("read from server before sending data\n");
  printf("result: %d bytes\n", server.readBytes((byte*)buf, 1024));

  int n;
	char * str1 = "client to server";
  char * str2 = "server to client";
  n = client.writeBytes((byte*)str1, strlen(str1)+1);
	printf("%d bytes send from client\n", n);
  n = server.writeBytes((byte*)str2, strlen(str2)+1);
	printf("%d bytes send from server\n", n);
  SDL_Delay(1000);
  
  printf("read from server\n");
  n = server.readBytes((byte*)buf, 1024);
  printf("read %d bytes\n", n);
  if (n<0)
    return -1;

  printf("data: %s\n", buf);
  printf("read from client\n");
  n = client.readBytes((byte*)buf, 1024);

  printf("read %d bytes\n", n);
  if (n<0)
    return -1;

  printf("data: %s\n", buf);

  return 0;
}

/**
 *
 *  main function
 *
 * here the journey begins
 */
int main(int argc, char** argv)
{
  // here the pre-arguments are loaded, these are needed to go either to orxonx itself, Help, or Benchmark.
  int i;
  for(i = 1; i < argc; ++i)
  {
    if(! strcmp( "--help", argv[i]) || !strcmp("-h", argv[i])) return startHelp(argc, argv);
    //else if(!strcmp( "--gui", argv[i]) || !strcmp("-g", argv[i])) showGui = true;
    else if (! strcmp( "--sockettest", argv[i]) || !strcmp("-s", argv[i])) return testSocket(argc, argv);
  }

  /* create the network manager */
  NetworkManager* nm = new NetworkManager();

  /* initialize the network manager */
  nm->initialize();

  /* esatblish a connection */
  nm->establishConnection();

  //ClassList::debug(3, 0);

  return 0;
}


bool ShellBuffer::addBufferLineStatic(const char* line, ...)
{
  va_list arguments;
  vprintf(line, arguments);

}
